﻿@model IEnumerable<WikiModel.Model.Group>

@{
    ViewBag.Title = @Caption.Index;
    Layout = "~/Views/Shared/_GroupLayout.cshtml";
}
<h2>@Caption.Index @Caption.Groups</h2>
<div class="row">
    <div class="col-md-12">
        @Html.ActionLink(@Caption.CreateNew, "Create", "Groups", new { @class = "btn btn-default col-md-1" })
        @Html.ActionLink(@Caption.GroupDocuments, "GroupDocuments", "Groups", new { @class = "btn btn-primary col-md-3" })
        @Html.ActionLink(@Caption.Search, "SearchDocuments", "Groups", new { @class = "btn btn-success col-md-2" })
   </div>
</div>
<br />
<div class="k-rtl k-header k-content ">
    <div id="my-treeview"></div>
</div>
<br />

@section JavaScript
{
    <script type="text/javascript">
        //$(document).ready(function(){
        //    alert("aaaaaaaaaaaaaaaaaa");
        //});
        $(function () {
            var dataSource = new kendo.data.HierarchicalDataSource({
                transport: {
                    read: {
                        @*url: "@Url.Action("TestDatas", "GetData")",*@
                        //url: "/Groups/GetData",
                        url: '@Url.Action("GetData", "Groups")',
                        dataType: "json",
                        contentType: 'application/json; charset=utf-8',
                        type: 'GET'
                    }
                },
                schema: {
                    model: {
                        id: "ID",
                        hasChildren: "HasChildren"
                    }
                }
            });
            $("#my-treeview").kendoTreeView({
                //استفاده از قالب در صورت نیاز
                template: kendo.template($("#treeview-template").html()),
                //checkboxes: {
                //    checkChildren: false
                //},
                dataSource: dataSource,
                dataTextField: "DisplayGroupName",
                dragAndDrop: true,
                expanded: true,
                loadOnDemand: false,
                //رخدادها
                //select: function (e) { console.log("Selecting: " + this.text(e.node)); },
                //check: function (e) { console.log("Checkbox changed :: " + this.text(e.node)); },
                //change: function (e) { console.log("Selection changed"); },
                //collapse: function (e) { console.log("Collapsing " + this.text(e.node)); },
                //expand: function (e) { console.log("Expanding " + this.text(e.node)); },
                //پیامها
                messages: { retry: "تلاش مجدد", requestFailed: "ایراد در دخواست", loading: "در حال واکشی داده ها ..." },

            });
        });

        $('#serialize').click(function () {
            //serialized = serialize();
            //window.location.href = "/Groups/SaveMenu?serial=" + serialized + "!";
            serialized = serialize();
            var url = '@Url.Action("SaveMenu", "Groups", new { serial = "__SaveMenu__" })';
            url = url.replace("__SaveMenu__", serialized + "!");
            window.location.href = url;
        });

        function serialize() {
            var tree = $("#my-treeview").data("kendoTreeView");
            tree.expand(".k-item");
            var json = treeToJson(tree.dataSource.view());
            var numbersAsStringsJSON = JSON.stringify(json, replacer);
            return numbersAsStringsJSON;
        }

        function replacer(key, value) {
            if (typeof value === "number") { return String(value); }
            else { return value; }
        }

        function treeToJson(nodes) {

            return $.map(nodes, function (n, i) {

                var result = { id: n.id };
                //var result = { text: n.text, id: n.id, expanded: n.expanded, checked: n.checked };
                if (n.hasChildren)
                    result.items = treeToJson(n.children.view());

                return result;
            });
        }
    </script>
    <script id="treeview-template" type="text/kendo-ui-template">
        #: item.DisplayGroupName #
        @Html.Raw(@Html.ActionLink(@Caption.Append, "Append", "Groups", new { id = "newID" }, null).ToHtmlString().Replace("newID", "#: item.id #"))
        @Html.Raw(@Html.ActionLink(@Caption.Edit, "Edit", "Groups", new { id = "newID" }, null).ToHtmlString().Replace("newID", "#: item.id #"))
        @*<a href="/Groups/Append/#: item.id #">@Caption.Append</a>
            <a href="/Groups/Edit/#: item.id #">@Caption.Edit</a>*@
        # if (!item.HasChildren){#
        @Html.Raw(@Html.ActionLink(@Caption.Delete, "Delete", "Groups", new { id = "newID" }, null).ToHtmlString().Replace("newID", "#: item.id #"))
        @*        <a href="/Groups/Delete/#: item.id #">@Caption.Delete</a>*@
        #}#
        @*@Html.ActionLink("Details", "Details", new { id = "newID" }).ToHtmlString().Replace("newID", "#: item.id #")*@
        @*# if (item.GroupName) { #*@
        @*@Html.ActionLink("Edit", "Edit", new { id = "newID" }) |
            @Html.ActionLink("Details", "Details", new { id = "newID" }).ToHtmlString().Replace("newID", "#: item.id #")) |
            @Html.ActionLink("Delete", "Delete", new { id = "newID" }).ToHtmlString().Replace("newID", "#: item.id #"))*@
        @*    # } #*@
    </script>

    @*<script id="treeview-template" type="text/kendo-ui-template">
            <strong> #: item.GroupName # </strong>
        </script>*@

    @*<style scoped>
            .demo-section {
                width: 100%;
                height: 100px;
                overflow:visible;
            }
        </style>*@
}
<div class="row">
    <div class="col-md-12">
        <a href="#" id="serialize" class="btn btn-default col-md-1">@Caption.Save</a>
    </div>
</div>

@*<table class="table">
        <tr>
            <th>
                @Html.DisplayNameFor(model => model.ID)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.ParentID)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.GroupName)
            </th>
            <th>
                @Html.DisplayNameFor(model => model.HasChildren)
            </th>
            <th></th>
        </tr>

        @foreach (var item in Model)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.ID)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.ParentID)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.GroupName)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.HasChildren)
                </td>
                <td>
                    @Html.ActionLink("Edit", "Edit", new { id = item.ID }) |
                    @Html.ActionLink("Details", "Details", new { id = item.ID }) |
                    @Html.ActionLink("Delete", "Delete", new { id = item.ID })
                </td>
            </tr>
        }

    </table>*@
